unit UFormTest2D;

interface

uses
  // Delphi includes:
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, DateUtils, Math, StdCtrls, Buttons, ComCtrls, ExtDlgs,
  Menus, AppEvnts,
  // Project includes:
  UTrack2D, UTeam, UKart;

type
  TFormTest2D = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Loadcircuit800x600BMP1: TMenuItem;
    Saveimagestofolder: TMenuItem;
    OpenPictureDialog: TOpenPictureDialog;
    SaveDialog: TSaveDialog;
    Graphicdebuglevels1: TMenuItem;
    MenuDebugTraces: TMenuItem;
    MenuDebugOptions: TMenuItem;
    MenuCleanTrack: TMenuItem;
    Panel3: TPanel;
    Panel2: TPanel;
    ImgRoad: TImage;
    Panel4: TPanel;
    GroupBox2: TGroupBox;
    Label6: TLabel;
    LbMaxPower: TLabel;
    Label7: TLabel;
    LbMax_Turn: TLabel;
    GroupBox3: TGroupBox;
    StartBtn: TSpeedButton;
    PauseBtn: TSpeedButton;
    GroupBox4: TGroupBox;
    Label5: TLabel;
    Label8: TLabel;
    LbFriction: TLabel;
    LbSideFriction: TLabel;
    GroupBox1: TGroupBox;
    GroupBox5: TGroupBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    Label3: TLabel;
    LbSize: TLabel;
    Label4: TLabel;
    LbRadio: TLabel;
    EdMaxPower: TTrackBar;
    EdMax_Turn: TTrackBar;
    EdSize: TTrackBar;
    EdFriction: TTrackBar;
    EdSideFriction: TTrackBar;
    EdRadio: TTrackBar;
    GroupBox6: TGroupBox;
    EdColor: TPanel;
    EdKartId: TComboBox;
    ColorDialog: TColorDialog;
    BtnAddKart: TSpeedButton;
    EdAutoRadio: TCheckBox;
    BtnReset: TSpeedButton;
    BtnSubKart: TSpeedButton;
    CBTeamScore: TCheckBox;
    EdCollisions: TCheckBox;
    LbSeconds: TLabel;
    Label2: TLabel;
    EdSeconds: TTrackBar;
    Label1: TLabel;
    LbMinFutures: TLabel;
    EdMinFutures: TTrackBar;
    Label9: TLabel;
    EdAI_Level: TComboBox;
    Addaformation1: TMenuItem;
    Addacircleofkarts1: TMenuItem;
    MenuDebugGoals: TMenuItem;
    Adddifferentgoals1: TMenuItem;
    MenuDebugTeamGoals: TMenuItem;
    Addateamgoalforcollectingdrops1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure StartBtnClick(Sender: TObject);
    procedure AddKart;
    procedure EdMaxPowerChange(Sender: TObject);
    procedure EdMax_TurnChange(Sender: TObject);
    procedure EdFrictionChange(Sender: TObject);
    procedure EdSideFrictionChange(Sender: TObject);
    procedure ResetBtnClick(Sender: TObject);
    procedure EdDebugChange(Sender: TObject);
    procedure CopyParamsFromScreen;
    procedure CopyParamsFromKart;
    procedure UpdateRealTimeParams;
    procedure Loadcircuit800x600BMP1Click(Sender: TObject);
    procedure SaveimagestofolderClick(Sender: TObject);
    procedure Pausesimulation1Click(Sender: TObject);
    procedure EdSecondsChange(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure EdSizeChange(Sender: TObject);
    procedure EdRadioChange(Sender: TObject);
    procedure BtnAddKartClick(Sender: TObject);
    procedure EdKartIdChange(Sender: TObject);
    procedure EdColorClick(Sender: TObject);
    procedure EdAutoRadioClick(Sender: TObject);
    procedure BtnSubKartClick(Sender: TObject);
    procedure CBTeamScoreClick(Sender: TObject);
    procedure MenuCleanTrackClick(Sender: TObject);
    procedure EdCollisionsClick(Sender: TObject);
    procedure EdMinFuturesChange(Sender: TObject);
    procedure EdAI_LevelChange(Sender: TObject);
    procedure Addacircleofkarts1Click(Sender: TObject);
    procedure Adddifferentgoals1Click(Sender: TObject);
    procedure Addateamgoalforcollectingdrops1Click(Sender: TObject);
  private
    ImgNumber: integer;
    MyTrack: TTrack2D;
    procedure ClearPlayers;
    function  GetMyTeam: TTeam;
    function  GetMyKart: TKart;
    procedure RunSimulation;
  public
    property MyTeam: TTeam read GetMyTeam;
    property MyKart: TKart read GetMyKart;
  end;

var
  FormTest2D: TFormTest2D;

implementation

uses UPlayer, UUtils, UGoal2dRotate, UGoal2dSweets;


{$R *.dfm}


// *************************
// ** ADMINISTRATVE STUFF **
// *************************

// Form creation: add a track, a team and a player, so it is ready to run:
procedure TFormTest2D.FormCreate(Sender: TObject);
begin
  randomize;
  OpenPictureDialog.InitialDir:= ExtractFilePath(ParamStr(0));
  SaveDialog.InitialDir:= ExtractFilePath(ParamStr(0));
  ImgNumber:= 1;
  // Create the track:
  MyTrack:= TTrack2D.create;
  // A sample track is already loaded, scan it for black pixels.
  MyTrack.Img:= ImgRoad;
  // Add a team to the track:
  MyTrack.AddTeam(TTeam.create);
  // Add a simple kart to the team:
  AddKart();

  {
  MyKart.PosY:= MyKart.PosY-80;
  MyKart.MaxPower:= 14;
  // Switch on team scoring:
  MyTeam.UseTeamScore:= true;

  // Second team with no AI:
  // Add a team to the track:
  MyTrack.AddTeam(TTeam.create);
  // Add a kart to the team:
  AddKart();
  MyKart.PosY:= MyKart.PosY-80;
  MyKart.MaxPower:= 14;
  // Switch on team scoring:
  MyTeam.UseTeamScore:= false;
  }
  
  // Initial draw:
  MyTrack.draw;
end;

// *********************
// **  ADD FORMATIONS **
// *********************

// Those formastions are for testing purpouse, the graphic interface doesn't
// allows you to set all the available options.

// Delete all players on the track:
procedure TFormTest2D.ClearPlayers;
begin
  while (MyTeam.PlayerCount > 0) do begin
    MyTeam.SelectedPlayer:= MyTeam.Player[0];
    MyTrack.DelPlayer(MyKart);
  end;
  EdKartId.Clear;
end;

// Add a formation: circle with 36 karts
procedure TFormTest2D.Addacircleofkarts1Click(Sender: TObject);
const NKart: integer = 36;
var i: integer;
begin
  // Del all players:
  ClearPlayers;
  // Add a cricle of N karts at (400, 300) radius 100
  for i:= 0 to (NKart-1) do begin
    AddKart();
    MyKart.MaxPower:= 14;
    MyKart.Size:= 8;
    MyKart.PosX:= 400 + 90 * cos(i*(2*PI/NKart));
    MyKart.PosY:= 300 + 90 * sin(i*(2*PI/NKart));
    MyKart.Angle:= PI + i*(2*PI/NKart);
    MyKart.SetIniState;
  end;
  // Redraw:
  MyTrack.draw;
end;

// Examples of personal goals:
procedure TFormTest2D.Adddifferentgoals1Click(Sender: TObject);
begin
  // Del all players:
  ClearPlayers;
  // First kart with no goal:
  AddKart();
  MyKart.MaxPower:= 16;
  // Second kart tend to rotate ccw:
  AddKart();
  MyKart.PosY:= MyKart.PosY - 20;
  MyKart.MaxPower:= 16;
  MyKart.AddGoal( TGoal2dRotate.create(-0.2, 400, 300));
  // Third kart likes orange drops:
  AddKart();
  MyKart.PosY:= MyKart.PosY - 20;
  MyKart.MaxPower:= 16;
  MyKart.AddGoal( TGoal2dSweets.create(3));
  // Redraw:
  MyTrack.draw;
end;

procedure TFormTest2D.Addateamgoalforcollectingdrops1Click(
  Sender: TObject);
begin
  // Add a sweet goal to the Team:
  MyTeam.AddGoal( TGoal2dSweets.create(3) );
end;


// ***************
// ** MAIN LOOP **
// ***************

procedure TFormTest2D.RunSimulation;
const
  // Each simulation tick correspond to 100 ms (0.1s).
  Sim_time: integer = 100;
  // Real CPU time I want the simulation to use:
  CPU_time: integer = 100;
begin
  Randomize;
  // Main loop is here, may be it should be moved inside TTrack and send a pointer
  // to this form so the track can update the input controls on the form.
  while StartBtn.Down do begin
    // Update karts:
    MyTrack.draw;
    MyTrack.DrawGoals;
    // Think about next frame and make all the moves:
    MyTrack.TakeAStep(CPU_time, Sim_time);
    // Update screen dials:
    UpdateRealTimeParams;
    // Refresh screen:
    Application.ProcessMessages;
    // Save image to folder?
    if Saveimagestofolder.Checked then begin
      ImgRoad.Picture.SaveToFile(SaveDialog.FileName+'_'+Format('%4.4d', [ImgNumber])+'.bmp');
      inc(ImgNumber);
    end;
  end;
end;


// ***********************************
// ** MANAGING PLAYERS ON THE TRACK **
// ***********************************

function TFormTest2D.GetMyTeam: TTeam;
begin
  result:= MyTrack.SelectedTeam;
end;

function TFormTest2D.GetMyKart: TKart;
begin
  result:= TKart(MyTeam.SelectedPlayer);
end;

// Pressed "Add" a new player to the team:
procedure TFormTest2D.BtnAddKartClick(Sender: TObject);
begin
  AddKart();
  MyTrack.Draw;
end;

// Add a player to the team:
procedure TFormTest2D.AddKart;
var
  MyOldKart: TKart;
begin
  // Remember old selected kart:
  MyOldKart:= MyKart;
  // Add a new one:
  MyTrack.AddPlayer(TKart.create(330, 520, 0));
  // Copy params from previusly selected kart:
  if Assigned(MyOldKart) then
    MyKart.CopyFrom(MyOldKart);
  // Remember it as your initial state:
  MyKart.SetIniState;
  // Asign visible colors:
  if (MyTrack.PlayerCount = 1) then MyKart.Color:= clWhite;
  if (MyTrack.PlayerCount = 2) then MyKart.Color:= clYellow;
  if (MyTrack.PlayerCount = 3) then MyKart.Color:= RGBToColor(255, 150, 50); // clOrange; //clLime;
  if (MyTrack.PlayerCount = 4) then MyKart.Color:= clRed;
  if (MyTrack.PlayerCount = 5) then MyKart.Color:= clBlack; // clFuchsia;
  // Add it to the combo box:
  EdKartId.Items.Add('Kart #'+IntToStr(MyTrack.PlayerCount));
  EdKartId.ItemIndex:= EdKartId.Items.Count-1;
  // Refresh screen image and controls:
  CopyParamsFromKart;
  MyTrack.Draw;
end;

// Delete actual kart from the team:
procedure TFormTest2D.BtnSubKartClick(Sender: TObject);
begin
  if MyTrack.PlayerCount > 1 then begin
    // Delete kart:
    MyTrack.DelPlayer(MyKart);
    // Take from the ComboBox list:
    EdKartId.Items.Delete(EdKartId.Items.Count-1);
    EdKartId.ItemIndex:= 0;
    // Redraw all:
    EdKartIdChange(Sender);
    MyTrack.ClearTrack;
    MyTrack.Draw;
  end;
end;

// Selected player is changed, so update screen dials:
procedure TFormTest2D.EdKartIdChange(Sender: TObject);
begin
  MyTeam.SelectedPlayer:= MyTeam.Player[EdKartId.ItemIndex];
  CopyParamsFromKart;
end;

// Chose another color for the selected kart:
procedure TFormTest2D.EdColorClick(Sender: TObject);
begin
  ColorDialog.Color:= EdColor.Color;
  if ColorDialog.Execute then begin
    EdColor.Color:= ColorDialog.Color;
    MyKart.Color:= EdColor.Color;
    MyTrack.Draw;
  end;
end;



// ***********************
// ** MENUS AND BUTTONS **
// ***********************

// RUN is pressed
procedure TFormTest2D.StartBtnClick(Sender: TObject);
begin
  // Activate the main loop:
  RunSimulation;
end;

// PAUSE simulation (from menu, button works auto):
procedure TFormTest2D.Pausesimulation1Click(Sender: TObject);
begin
  PauseBtn.Down:= true;
end;

// RESET pressed:
procedure TFormTest2D.ResetBtnClick(Sender: TObject);
var
  t: integer;
begin
  ImgNumber:= 1;
  for t:= 0 to MyTrack.TeamCount-1 do
    MyTrack.Team[t].ResetState;
  CopyParamsFromScreen;
  MyTrack.Draw;
end;

// See trails of players as they move (menu):
procedure TFormTest2D.MenuCleanTrackClick(Sender: TObject);
begin
  MyTrack.SeeTrails:= not MenuCleanTrack.Checked;
end;

// Loading a new image for the track form menu:
procedure TFormTest2D.Loadcircuit800x600BMP1Click(Sender: TObject);
begin
  if OpenPictureDialog.Execute then begin
    ImgRoad.Picture.LoadFromFile(OpenPictureDialog.FileName);
    // Scan new track:
    MyTrack.Img:= ImgRoad;
    // Repaint karts on it:
    MyTrack.Draw;
  end;
end;

// Selecting a folder (and file name) where to save images:
procedure TFormTest2D.SaveimagestofolderClick(Sender: TObject);
begin
  // Switch on/off image recording:
  if SaveImagesToFolder.Checked then begin
    if not SaveDialog.Execute then
      SaveImagesToFolder.Checked:= false;
  end;
end;


// ***********************
// ** SIMULATION PARAMS **
// ***********************

// Transfer screen params to the actual player and track:
procedure TFormTest2D.CopyParamsFromScreen;
begin
  // Kart params:
  EdMaxPowerChange(nil);
  EdMax_TurnChange(nil);
  EdSizeChange(nil);
  // Track params.
  EdFrictionChange(nil);
  EdSideFrictionChange(nil);
  CBTeamScoreClick(nil);
  // Think params.
  EdSecondsChange(nil);
  EdMinFuturesChange(nil);
  EdRadioChange(nil);
  EdAutoRadioClick(nil);
  EdCollisionsClick(nil);
  EdAI_LevelChange(nil);
  // Debug params.
  EdDebugChange(nil);
end;

// Transfer params from the actual player and track to screen:
procedure TFormTest2D.CopyParamsFromKart;
begin
  EdSeconds.Position:=      round(MyTrack.FutureMSeconds/1000);
  EdMinFutures.Position:=   MyTrack.MinFutures;
  EdMaxPower.Position:=     round(MyKart.MaxPower);
  EdMax_Turn.Position:=     round(MyKart.MaxTurn/PI*180);
  EdSize.Position:=         round(MyKart.Size);
  EdFriction.Position:=     round(MyTrack.Friction*1000);
  EdSideFriction.Position:= round(MyTrack.SideFriction*100);
  EdColor.Color:=           MyKart.Color;
  EdAutoRadio.Checked:=     MyKart.AutoGridSize;
  CBTeamScore.Checked:=     MyTeam.UseTeamScore;
  EdAI_Level.ItemIndex:=    MyKart.AI_Level - 1;
  // Read params that change during simulation:
  UpdateRealTimeParams();
  // Debug on menu:
  MenuDebugTraces.Checked:=  MyKart.DebugTraces;
  MenuDebugOptions.Checked:= MyKart.DebugOptions;
  MenuDebugGoals.Checked:=   MyKart.DebugGoals;
  // Update labels:
  CopyParamsFromScreen;
end;

// Only some params do change during simulation, only refresh those:
procedure TFormTest2D.UpdateRealTimeParams;
begin
  EdRadio.Position:= round(MyKart.GridSize);
end;


// ************************
// ** CHANGING ONE PARAM **
// ************************

procedure TFormTest2D.EdMinFuturesChange(Sender: TObject);
begin
  MyTrack.MinFutures:= EdMinFutures.Position;
  LbMinFutures.Caption:= IntToStr(EdMinFutures.Position);
end;

procedure TFormTest2D.EdAutoRadioClick(Sender: TObject);
begin
  MyKart.AutoGridSize:= EdAutoRadio.Checked;
end;

procedure TFormTest2D.EdMaxPowerChange(Sender: TObject);
begin
  LbMaxPower.Caption:= IntToStr(EdMaxPower.Position);
  MyKart.MaxPower:= EdMaxPower.Position;
end;

procedure TFormTest2D.EdMax_TurnChange(Sender: TObject);
begin
  LbMax_Turn.Caption:= FloatToStr(EdMax_Turn.Position)+'';
  MyKart.MaxTurn:=  EdMax_Turn.Position/180*PI;
end;

procedure TFormTest2D.EdFrictionChange(Sender: TObject);
begin
  LbFriction.Caption:= FloatToStr(EdFriction.Position/1000);
  MyTrack.Friction:= EdFriction.Position/1000;
end;

procedure TFormTest2D.EdSideFrictionChange(Sender: TObject);
begin
  LbSideFriction.Caption:=  FloatToStr(EdSideFriction.Position/100);
  MyTrack.SideFriction:= EdSideFriction.Position/100;
end;

// Wahat to debug?
procedure TFormTest2D.EdDebugChange(Sender: TObject);
begin
  MyKart.DebugTraces:=  MenuDebugTraces.Checked;
  MyKart.DebugOptions:= MenuDebugOptions.Checked;
  MyKart.DebugGoals:=   MenuDebugGoals.Checked;
  MyTeam.DebugGoals:=   MenuDebugTeamGoals.Checked;
end;

procedure TFormTest2D.EdSizeChange(Sender: TObject);
begin
  MyKart.Size:= EdSize.Position;
  LbSize.Caption:= IntToStr(EdSize.Position)+ 'px';
  MyTrack.Draw;
end;

procedure TFormTest2D.EdRadioChange(Sender: TObject);
begin
  MyKart.GridSize:= EdRadio.Position;
  LbRadio.Caption:= IntToStr(EdRadio.Position)+ 'px';
end;

procedure TFormTest2D.EdSecondsChange(Sender: TObject);
begin
  MyTrack.FutureMSeconds:= EdSeconds.Position * 1000;
  LbSeconds.Caption:= IntToStr(EdSeconds.Position)+' s.'
end;

procedure TFormTest2D.CBTeamScoreClick(Sender: TObject);
begin
  MyTeam.UseTeamScore:= CBTeamScore.Checked;
end;

procedure TFormTest2D.EdCollisionsClick(Sender: TObject);
begin
  MyTrack.WatchCollisions:= EdCollisions.Checked;
end;

procedure TFormTest2D.EdAI_LevelChange(Sender: TObject);
begin
  MyKart.AI_Level:= EdAI_Level.ItemIndex + 1;
end;

// *******************************
// ** MOVING THE PLAYER BY HAND **
// *******************************

procedure TFormTest2D.SpeedButton1Click(Sender: TObject);
begin
  MyKart.HandMove(-5, 0, 0);
  if not StartBtn.Down then MyKart.SetIniState;
end;

procedure TFormTest2D.SpeedButton3Click(Sender: TObject);
begin
  MyKart.HandMove(5, 0, 0);
  if not StartBtn.Down then MyKart.SetIniState;
end;

procedure TFormTest2D.SpeedButton2Click(Sender: TObject);
begin
  MyKart.HandMove(0, -5, 0);
  if not StartBtn.Down then MyKart.SetIniState;
end;

procedure TFormTest2D.SpeedButton4Click(Sender: TObject);
begin
  MyKart.HandMove(0, 5, 0);
  if not StartBtn.Down then MyKart.SetIniState;
end;

procedure TFormTest2D.SpeedButton5Click(Sender: TObject);
begin
  MyKart.HandMove(0, 0, +PI/12);
  if not StartBtn.Down then MyKart.SetIniState;
end;

procedure TFormTest2D.SpeedButton6Click(Sender: TObject);
begin
  MyKart.HandMove(0, 0, -PI/12);
  if not StartBtn.Down then MyKart.SetIniState;
end;


end.
