unit UGoal2DSweets;

interface

uses UGoal, UPlayer2D;


type TGoal2DSweets = class(TGoal)
  private
    FirstRun: boolean;
    X: array [0..99] of integer;
    Y: array [0..99] of integer;
    S: array [0..99] of integer; // Sweet points scores
  protected
  public
    constructor create(c: double); override;
    procedure Draw(player: TObject); override;
    procedure ScoreGoal(player: TObject); override;
  end;

const
  NDrops: integer = 100;


implementation

uses UTrack2D, Graphics, ExtCtrls;


constructor TGoal2DSweets.create(c: double);
var
  i: integer;
begin
  inherited;
  fDrawable:= true;
  fPersonalizedDrawing:= false; // One drawing per team is ok.
  FirstRun:= true;
  for i:= 0 to NDrops-1 do
    S[i]:= 2+round(random*5);
end;

procedure TGoal2DSweets.ScoreGoal(player: TObject);
var
  p: TPlayer2D;
  Img: TImage;
  i: integer;
  IsInside: boolean;
begin
  inherited;
  p:= TPLayer2D(player);
  if p.Dead then exit;
  Img:= TTrack2D(p.Track).Img;
  // Add 100 sweets on the track if not already done:
  if FirstRun then begin
    for i:= 0 to NDrops-1 do begin
      repeat
        X[i]:= round((0.1 + random*0.8)*Img.Width);
        Y[i]:= round((0.1 + random*0.8)*Img.Height);
        IsInside:= TTrack2D(p.Track).IsInsideTrack(X[i], Y[i]) and
                 TTrack2D(p.Track).IsInsideTrack(round(X[i]+p.Size), Y[i]) and
                 TTrack2D(p.Track).IsInsideTrack(round(X[i]-p.Size), Y[i]) and
                 TTrack2D(p.Track).IsInsideTrack(X[i], round(Y[i]+p.Size)) and
                 TTrack2D(p.Track).IsInsideTrack(X[i], round(Y[i]-p.Size));
      until IsInside;
    end;
    FirstRun:= false;
  end;
  // When you come near one drop, the scoring of the drop get added:
  for i:= 0 to NDrops-1 do begin
    if (S[i]>0) and (abs(p.PosX-X[i])<p.Size) and (abs(p.PosY-Y[i])<p.Size) then begin
      Score:= Score + S[i];
      // If it is real, kill this sweet:
      if not p.Imagining then
        S[i]:= 0;
    end;
  end;
end;

procedure TGoal2dSweets.Draw(player: TObject);
var
  p: TPlayer2D;
  C: TCanvas;
  i: integer;
begin
  if FirstRun then exit;
  p:= TPlayer2D(player);
  C:= TTrack2D(p.Track).Img.Canvas;
  // A circle on the sweets:
  C.Brush.Color:= clCream;
  C.Pen.Color:= clGreen;
  for i:= 0 to NDrops-1 do
    if (S[i] > 0) then
      C.Ellipse(round(X[i]-S[i]), round(Y[i]-S[i]), round(X[i]+S[i]), round(Y[i]+S[i]));
end;

end.
